/*******************************************************************************/
/* peephole.h - peephole main header file 				       */
/*  v. 0.1 								       */
/*  Copyright (C) 2004 Alessandro Di Marco - All rights reserved 	       */
/*  by Alessandro Di Marco <dmr@gmx.it>	                 		       */
/* 									       */
/* This program is free software; you can redistribute it and/or 	       */
/* modify  under the terms of the GNU General Public License as 	       */
/* published by the Free Software Foundation; either version 2, or (at 	       */
/* your option) any later version.					       */
/* 									       */
/* This program is distributed in the hope that it will be useful, but 	       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of 		       */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 	       */
/* General Public License for more details.				       */
/* 									       */
/* You should have received a copy of the GNU General Public License 	       */
/* along with GNU Emacs; see the file COPYING.  If not, write to the 	       */
/* Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.	       */
/*******************************************************************************/
/*
 *  $Header: /var/cvsroot/peephole/src/peephole.h,v 1.5 2004/04/18 20:58:53 dmr Exp $
 *
 */

#ifndef PEEPHOLE_H
#define PEEPHOLE_H

#define WM_VERSION PACKAGE " " VERSION

#define FATAL(x) { perror(PACKAGE " " x); exit(EXIT_FAILURE); }

#define WM_ON	1
#define WM_OFF	0

#include "list.h"

struct wm_ring {
	char *identifier;
	int status;
};

struct wm_coil {
	struct list_head others;
	struct wm_ring rings[];
};

#define MYADDRESS INADDR_ANY
#define MYPORT 3490

#define BACKLOG 10

#define RESOLVE_WARMUP	3	/* secs */
#define RESOLVE_TIMEOUT	60	/* secs */

#define PEEP_RAW	1
#define PEEP_COOKED	2

struct wm_client {
	struct list_head others;
	int mode;
	int fd;
};

#endif /* PEEPHOLE_H */
