/*************************************************************************/
/* apop.h - header apop module for peephole				 */
/*  v. 0.0.0 								 */
/*  Copyright (C) 2004 Paolo Ardoino, Alessandro Di Marco		 */
/*  by Paolo Ardoino  <ardoino.gnu@disi.unige.it> 			 */
/*  									 */
/* This program is free software; you can redistribute it and/or 	 */
/* modify it under the terms of the GNU General Public License as 	 */
/* published by the Free Software Foundation; either version 2 of the 	 */
/* License, or (at your option) any later version.			 */
/* 									 */
/* This program is distributed in the hope that it will be useful, but 	 */
/* WITHOUT ANY WARRANTY; without even the implied warranty of 		 */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 	 */
/* General Public License for more details.				 */
/*  									 */
/* You should have received a copy of the GNU General Public License 	 */
/* along with this program; if not, write to the Free Software 		 */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-	 */
/* 1307, USA.								 */
/*************************************************************************/

/*
 *  $Header: /var/cvsroot/peephole/src/providers/apop/apop.h,v 1.7 2004/04/18 20:58:53 dmr Exp $
 *
 *  Copyright (C) 2004 Paolo Ardoino, Alessandro Di Marco
 */

#ifndef APOP_H
#define APOP_H

#include <netdb.h>

#define BUFFER_SIZE 512

#define READ_BUFFER(buf) do { fgets((buf), BUFFER_SIZE, sf); (buf)[strlen(buf) - 2] = '\0'; } while(0)
#define WRITE_BUFFER(buf) do { fputs((buf), sf); fputs("\r\n", sf); } while(0)

#define OK_BUFFER(buf) (!strncmp(buf, "+OK", 3))
#define ERR_BUFFER(buf) (!strncmp(buf, "-ERR", 4))

static void bin2hex(unsigned char *inbuf, unsigned char *outbuf);
static void md5_hash(char *inbuf);

static void *open_apop(struct hostent *hent, int port, char *user, char *password);
static void close_apop(void *sf);
static int stat_apop(void *sf, int *msgs, int *last);
static int match_apop(void *sf, int msg, signaler_cb signaler, void *arg);

#endif /* APOP_H */
