/*
 *  $Header: /var/cvsroot/peephole/src/providers/fake/fake.c,v 1.3 2004/04/05 22:51:19 dmr Exp $
 *
 *  Copyright (C) 2004 Alessandro Di Marco
 */

/*
 *  TODO:
 */

#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#include <asm/errno.h>

#include "../providers.h"

#include "fake.h"

static const char cvsid[]="$Id: fake.c,v 1.3 2004/04/05 22:51:19 dmr Exp $";

static long offsets[100] = { 0, };

static void *open_fake(struct hostent *hent, int port, char *user, char *password)
{
	char *server = (char *) hent;
	FILE *fp;

	fp = fopen(server, "r");
	if (!fp) {
		fprintf(stderr, "file not found: %s\n", server);
	}

	return fp;
}

static void close_fake(void *fp)
{
	fclose(fp);
}

static int stat_fake(void *fp, int *msgs, int *last)
{
	int i;
	char cmd[BUFFER_SIZE];

	fseek(fp, 0, SEEK_SET);

	for (i = 0; fgets(cmd, BUFFER_SIZE, fp);) {
		if (!strncmp(cmd, ".", 1)) {
			offsets[++i] = ftell(fp);
		}
	}

	*last = rand() % (*msgs = 1 + rand() % i);

	return 0;
}

static int match_fake(void *fp, int msg, signaler_cb signaler, void *arg)
{
	char cmd[50 * BUFFER_SIZE];
	int pos;

	fseek(fp, offsets[msg - 1], SEEK_SET);

        /*  FIXME: cmd boundary is unchecked here! */
	for (pos = 0; fgets(cmd + pos, BUFFER_SIZE, fp); pos += strlen(cmd + pos)) {
		if (!strncmp(cmd + pos, ".", 1)) {
			signaler(cmd, arg);

			return 0;
		}
	}

	fprintf(stderr, "troubles in faked message %d\n", msg);

	return -EFAULT;
}

struct wm_providers_stub hooks = {
	open_fake,
	close_fake,
	stat_fake,
	match_fake
};
