/*
 *  $Header: /var/cvsroot/peephole/src/providers/pop3/pop3.h,v 1.4 2004/04/18 20:58:53 dmr Exp $
 *
 *  Copyright (C) 2004 Alessandro Di Marco
 */

#ifndef POP3_H
#define POP3_H

#include <netdb.h>

#define BUFFER_SIZE 512

#define READ_BUFFER(buf) do { fgets((buf), BUFFER_SIZE, sf); (buf)[strlen(buf) - 2] = '\0'; } while(0)
#define WRITE_BUFFER(buf) do { fputs((buf), sf); fputs("\r\n", sf); } while(0)

#define OK_BUFFER(buf) (!strncmp(buf, "+OK", 3))
#define ERR_BUFFER(buf) (!strncmp(buf, "-ERR", 4))

static void *open_pop3(struct hostent *hent, int port, char *user, char *password);
static void close_pop3(void *sf);
static int stat_pop3(void *sf, int *msgs, int *last);
static int match_pop3(void *sf, int msg, signaler_cb signaler, void *arg);

#endif /* POP3_H */
