/*************************************************************************/
/* pop3s.h - header pop3s module for peephole				 */
/*  v. 0.0.0 								 */
/*  Copyright (C) 2004 Paolo Ardoino, Alessandro Di Marco		 */
/*  by Paolo Ardoino  <ardoino.gnu@disi.unige.it> 			 */
/*  									 */
/* This program is free software; you can redistribute it and/or 	 */
/* modify it under the terms of the GNU General Public License as 	 */
/* published by the Free Software Foundation; either version 2 of the 	 */
/* License, or (at your option) any later version.			 */
/* 									 */
/* This program is distributed in the hope that it will be useful, but 	 */
/* WITHOUT ANY WARRANTY; without even the implied warranty of 		 */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU 	 */
/* General Public License for more details.				 */
/*  									 */
/* You should have received a copy of the GNU General Public License 	 */
/* along with this program; if not, write to the Free Software 		 */
/* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-	 */
/* 1307, USA.								 */
/*************************************************************************/

/*
 *  $Header: /var/cvsroot/peephole/src/providers/pop3s/pop3s.h,v 1.5 2004/04/05 22:51:19 dmr Exp $
 *
 *  Copyright (C) 2004 Paolo Ardoino, Alessandro Di Marco
 */

#ifndef POPS3_H
#define POPS3_H

#include <netdb.h>

#define MAX_THREADS 100

#define BUFFER_SIZE 512

#define READ_BUFFER(ssl, buf) do { SSL_read((SSL *) ssl, (buf), BUFFER_SIZE); (buf)[strlen(buf) - 2] = '\0'; } while(0)
#define WRITE_BUFFER(ssl, buf) do { SSL_write((SSL *) ssl, (buf), strlen(buf)); } while(0)

#define OK_BUFFER(buf) (!strncmp(buf, "+OK", 3))
#define ERR_BUFFER(buf) (!strncmp(buf, "-ERR", 4))

static void ssl_thread_setup(void);
static void ssl_thread_cleanup(void);
static void locking_function(int mode, int type, const char *file, int line);
static unsigned long id_function(void);

static void *open_pop3s(struct hostent *hent, int port, char *user, char *password);
static void close_pop3s(void *ssl);
static int stat_pop3s(void *ssl, int *msgs, int *last);
static int match_pop3s(void *ssl, int msg, signaler_cb signaler, void *arg);

#endif /* POP3S_H */
